﻿/*
Ten plik:
- przeszedł bardzo uważny przegląd
- nadal może zawierać błędy w kodzie powodujące błędy kompilatora
- jest niezdebugowany
- jest nieprzetestowany
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Loz
{
    enum StanyGracza
    {
        WLewo,
        Żaden,
        WPrawo
    }

    enum StanyPrzeciwnika
    {
        ParabolaWLewo,
        ParabolaWPrawo,
        KontynuujPoziomoWLewo,
        KontynuujPoziomoWPrawo,
        Schodzenie
    }

    internal class StatekGracza
    {
        public int StanGracza;
        public double X;
        public double Y;

        public StatekGracza()
        {
            StanGracza = (int)StanyGracza.Żaden;
            X = 0.0;
            Y = 0.0;
        }
    }

    internal class Przeciwnik
    {
        public bool CzyIstnieje;
        public int StanPrzeciwnika;
        public double X;
        public double Y;
        public double IleJeszczeSchodzić;

        public Przeciwnik()
        {
            CzyIstnieje = false;
            StanPrzeciwnika = (int)StanyPrzeciwnika.Schodzenie;
            X = 0.0;
            Y = 0.0;
            IleJeszczeSchodzić = 0.0;
        }
    }

    internal class Pocisk
    {
        public bool CzyIstnieje;
        public double X;
        public double Y;

        public Pocisk()
        {
            CzyIstnieje = false;
            X = 0.0;
            Y = 0.0;
        }
    }

    public class Silnik
    {
        private int liczbaPunktów;
        private int liczbaŻyć;
        private bool graSkończona; // ustawienie tej wartości na true powoduje zakończenie gry

        public int LiczbaPunktów {
            get { return liczbaPunktów; }
        }

        public int LiczbaŻyć {
            get { return liczbaŻyć; }
        }

        public bool GraSkończona {
            get { return graSkończona; }
        }
        public int MaxLiczbaPrzeciwników { get { return przeciwnicy.Length; } }
        public int MaxLiczbaPociskówGracza { get { return pociskiGracza.Length; } }
        public int MaxLiczbaPociskówWroga { get { return pociskiWroga.Length; } }
        public int PrzestrzeńXpx { get { return przestrzeńXpx; } }
        public int PrzestrzeńYpx { get { return przestrzeńYpx; } }

        private StatekGracza statekGracza;
        private Przeciwnik[] przeciwnicy;
        private Pocisk[] pociskiGracza;
        private Pocisk[] pociskiWroga;
        private int miliSekundy;
        private int maksymalnaLiczbaPrzeciwników;
        private int maksymalnaLiczbaPociskówGracza;
        private int przestrzeńXpx;
        private int przestrzeńYpx;
        private double graczHitboxX;
        private double graczHitboxY;
        private double graczDługośćKroku;
        private double przeciwnikHitboxX;
        private double przeciwnikHitboxY;
        private double przeciwnikDługośćKroku;
        private double pociskHitboxX; // wspólne dla pocisków gracza i wroga
        private double pociskHitboxY; // wspólne dla pocisków gracza i wroga
        private double pociskGraczaDługośćKroku;
        private int deltaPKT; // o ile wzrastają punkty za jednego przeciwnika
        private int czas2; // ile okresów pomiędzy wejściem dwóch kolejnych przeciwników
        private int czasOddziałów; // ile okresów pomiędzy wejściem kolejnego oddziału

        private int globalnyCzas2; // odmierzające czas
        private int globalnyCzasOddziałów; // odmierzające czas
        private int wielkośćOdziału;
        private int ileJeszczeWrogówWyprodukować;
        private bool czyProdukowaćWrogówZLewej;

        private int maksymalnaLiczbaPociskówWroga;
        private int rzadkośćStrzelania;

        private double pociskWrogaDługośćKroku;

        public Silnik()
        {
            statekGracza = null; // ta linia jest zasadniczo zbędna
            przeciwnicy = null; // ta linia jest zasadniczo zbędna
            pociskiGracza = null; // ta linia jest zasadniczo zbędna
            pociskiWroga = null; // ta linia jest zasadniczo zbędna
                                 // nie inicjalizować tu zwykłych pól, bo robi to metoda Resetuj
        }

        private static bool CzyNie01(double x)
        {
            if (x <= 0.0 || 1.0 < x) return true;
            return false;
        }

        private static int Losuj(int min, int max)
        {
            Random r = new Random();
            return r.Next(min, max);
        }

        private static double WartośćParabolaWPrawo(double x)
        {
            return (2.5 * x - 1.5) * x + 0.6;
        }

        private static double WartośćParabolaWLewo(double x)
        {
            return 0.5 * x * (5.0 * x - 7.0) + 1.6;
        }

        public void Resetuj(int X = 800, int Y = 600, int MS = 16, double GHX = 0.08,
            double GHY = 0.1, double GDR = 0.008, int NP = 64, double PHX = 0.08,
            double PHY = 0.1, double PDR = 0.008, int NPO = 2, double POHX = 0.01,
            double POHY = 0.08, double POGDR = 0.032, int Ż = 3, int PPKT = 100,
            int T2 = 40, int TO = 300, int WNPO = 10, int rS = 40, double POWDR = 0.008)
        {
            if (X <= 0)
            {
                throw new ArgumentException("Nieprawidłowy rozmiar przestrzenii gry w pikselach. (X)");
            }

            if (Y <= 0)
            {
                throw new ArgumentException("Nieprawidłowy rozmiar przestrzenii gry w pikselach. (Y)");
            }

            if (MS < 0)
            {
                throw new ArgumentException("Nieprawidłowy okres opóźnienia pracy silnika. (MS)");
            }

            if (Silnik.CzyNie01(GHX))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a statku gracza. (GHX)");
            }

            if (Silnik.CzyNie01(GHY))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a statku gracza. (GHY)");
            }

            if (GDR <= 0.0)
            {
                throw new ArgumentException("Nieprawidłowa wartość kroku przestrzennego statku gracza. (GDR)");
            }

            if (NP <= 0)
            {
                throw new ArgumentException("Nieprawidłowa maksymalna liczba przeciwników jednocześnie w grze. (NP)");
            }

            if (Silnik.CzyNie01(PHX))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a statku przeciwnika. (PHX)");
            }

            if (Silnik.CzyNie01(PHY))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a statku przeciwnika. (PHY)");
            }

            if (PDR <= 0.0)
            {
                throw new ArgumentException("Nieprawidłowa wartość kroku przestrzennego statku przeciwnika. (PDR)");
            }

            if (NPO <= 0)
            {
                throw new ArgumentException("Nieprawidłowa maksymalna liczba pocisków gracza jednocześnie w grze. (NPO)");
            }

            if (Silnik.CzyNie01(POHX))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a pocisku. (POHX)");
            }

            if (Silnik.CzyNie01(POHY))
            {
                throw new ArgumentException("Nieprawidłowa wielkość hitbox'a pocisku. (POHY)");
            }

            if (POGDR <= 0.0)
            {
                throw new ArgumentException("Nieprawidłowa wartość kroku przestrzennego pocisku gracza. (POGDR)");
            }

            if (Ż <= 0)
            {
                throw new ArgumentException("Nieprawidłowa maksymalna liczba żyć. (Ż)");
            }

            if (PPKT <= 0 || 1000 < PPKT)
            {
                throw new ArgumentException("Nieprawidłowa liczba punktów za jednego pokonanego przeciwnika. (PPKT)");
            }

            if (T2 <= 0)
            {
                throw new ArgumentException("Nieprawidłowy okres odstępu między pojawieniem się dwóch kolejnych przeciwników. (T2)");
            }

            if (TO <= 0 || TO <= T2)
            {
                throw new ArgumentException("Nieprawidłowy okres odstępu między pojawieniem się dwóch kolejnych oddziałów przeciwników. (TO)");
            }

            if (WNPO <= 0)
            {
                throw new ArgumentException("Nieprawidłowa maksymalna liczba pocisków wroga jednocześnie w grze. (WNPO)");
            }

            if (rS <= 0)
            {
                throw new ArgumentException("Nieprawidłowa rzadkość strzelania. (rS)");
            }

            if (POWDR <= 0.0)
            {
                throw new ArgumentException("Nieprawidłowa wartość kroku przestrzennego pocisku wroga. (POWDR)");
            }

            if (statekGracza == null)
            {
                statekGracza = new StatekGracza();
            }

            if (przeciwnicy == null || NP != maksymalnaLiczbaPrzeciwników)
            {
                przeciwnicy = null; // ta linia jest zasadniczo zbędna
                                    // resztą się zajmie Garbage Collector
                                    // jeśli się nie kompiluje, zakomentować linię o 2 wyżej niż ta, a dalej i tak przypisywane jest coś innego:
                przeciwnicy = new Przeciwnik[NP];
                for (int i = 0; i < przeciwnicy.Length; i++)
                {
                    przeciwnicy[i] = new Przeciwnik();
                }
            }

            if (pociskiGracza == null || NPO != maksymalnaLiczbaPociskówGracza)
            {
                pociskiGracza = null; // ta linia jest zasadniczo zbędna
                                      // resztą się zajmie Garbage Collector
                                      // jeśli się nie kompiluje, zakomentować linię o 2 wyżej niż ta, a dalej i tak przypisywane jest coś innego:
                pociskiGracza = new Pocisk[NPO];
                for (int i = 0; i < pociskiGracza.Length; i++)
                {
                    pociskiGracza[i] = new Pocisk();
                }
            }

            if (pociskiWroga == null || WNPO != maksymalnaLiczbaPociskówWroga)
            {
                pociskiWroga = null; // ta linia jest zasadniczo zbędna
                                     // resztą się zajmie Garbage Collector
                                     // jeśli się nie kompiluje, zakomentować linię o 2 wyżej niż ta, a dalej i tak przypisywane jest coś innego:
                pociskiWroga = new Pocisk[WNPO];
                for (int i = 0; i < pociskiWroga.Length; i++)
                {
                    pociskiWroga[i] = new Pocisk();
                }
            }

            graSkończona = false;
            liczbaPunktów = 0;
            liczbaŻyć = Ż;

            miliSekundy = MS;
            maksymalnaLiczbaPrzeciwników = NP;
            maksymalnaLiczbaPociskówGracza = NPO;

            przestrzeńXpx = X;
            przestrzeńYpx = Y;
            graczHitboxX = GHX;
            graczHitboxY = GHY;
            graczDługośćKroku = GDR;
            przeciwnikHitboxX = PHX;
            przeciwnikHitboxY = PHY;
            przeciwnikDługośćKroku = PDR;
            pociskHitboxX = POHX;
            pociskHitboxY = POHY;
            pociskGraczaDługośćKroku = POGDR;
            deltaPKT = PPKT;
            czas2 = T2;
            czasOddziałów = TO;

            globalnyCzas2 = 0;
            globalnyCzasOddziałów = 0;
            wielkośćOdziału = 1;
            ileJeszczeWrogówWyprodukować = 0;
            czyProdukowaćWrogówZLewej = false;

            maksymalnaLiczbaPociskówWroga = WNPO;
            rzadkośćStrzelania = rS;

            pociskWrogaDługośćKroku = POWDR;

            statekGracza.StanGracza = (int)StanyGracza.Żaden;
            statekGracza.X = 0.5;
            statekGracza.Y = 1.5 * graczHitboxY;
            for (int i = 0; i < przeciwnicy.Length; i++)
            {
                przeciwnicy[i].CzyIstnieje = false;
                przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.Schodzenie;
                przeciwnicy[i].IleJeszczeSchodzić = 0.0;
            }
            for (int i = 0; i < pociskiGracza.Length; i++)
            {
                pociskiGracza[i].CzyIstnieje = false;
            }
            for (int i = 0; i < pociskiWroga.Length; i++)
            {
                pociskiWroga[i].CzyIstnieje = false;
            }
        }

        public void PrzeskalujRozmiary(int X, int Y)
        {
            if (X <= 0)
            {
                throw new ArgumentException("Nieprawidłowy rozmiar przestrzenii gry w pikselach. (X)");
            }

            if (Y <= 0)
            {
                throw new ArgumentException("Nieprawidłowy rozmiar przestrzenii gry w pikselach. (Y)");
            }

            przestrzeńXpx = X;
            przestrzeńYpx = Y;
        }

        /*private*/
        public void DodajPrzeciwnika(bool CzyZLewej) //dla testów jednostkowych
        {
            int i;

            i = 0;
            while (i < przeciwnicy.Length)
            {
                if (!(przeciwnicy[i].CzyIstnieje)) break;
                i++;
            }

            if (i < przeciwnicy.Length)
            {
                przeciwnicy[i].CzyIstnieje = true;
                przeciwnicy[i].IleJeszczeSchodzić = 0.0;
                if (CzyZLewej)
                {
                    przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.ParabolaWPrawo;
                    przeciwnicy[i].X = 0.5 * przeciwnikHitboxX;
                    przeciwnicy[i].Y = Silnik.WartośćParabolaWPrawo(przeciwnicy[i].X);
                }
                else
                {
                    przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.ParabolaWLewo;
                    przeciwnicy[i].X = 1.0 - 0.5 * przeciwnikHitboxX;
                    przeciwnicy[i].Y = Silnik.WartośćParabolaWLewo(przeciwnicy[i].X);
                }
            }
        }

        private void DodajPociskGracza(double X, double Y)
        {
            int i;

            i = 0;
            while (i < pociskiGracza.Length)
            {
                if (!(pociskiGracza[i].CzyIstnieje)) break;
                i++;
            }

            if (i < pociskiGracza.Length)
            {
                pociskiGracza[i].CzyIstnieje = true;
                pociskiGracza[i].X = X;
                pociskiGracza[i].Y = Y;
            }
        }

        private void DodajPociskWroga(double X, double Y)
        {
            int i;

            i = 0;
            while (i < pociskiWroga.Length)
            {
                if (!(pociskiWroga[i].CzyIstnieje)) break;
                i++;
            }

            if (i < pociskiWroga.Length)
            {
                pociskiWroga[i].CzyIstnieje = true;
                pociskiWroga[i].X = X;
                pociskiWroga[i].Y = Y;
            }
        }

        public void WykonajKrok()
        {
            this.DodajNowychPrzeciwników();
            this.WykonajKrokGracza();
            this.WykonajKrokiPrzeciwników();
            this.WykonajKrokiPocisków();
            this.WykryjKolizjeGracza();
            this.WykryjKolizjePocisków();
            System.Threading.Thread.Sleep(miliSekundy);
        }

        private void DodajNowychPrzeciwników()
        {
            // Fabryka wrogów:
            Random losujCzyZLewej = new Random();
            int k;
            globalnyCzasOddziałów--;
            globalnyCzas2--;
            if (globalnyCzasOddziałów <= 0)
            {
                globalnyCzasOddziałów = czasOddziałów;
                ileJeszczeWrogówWyprodukować += wielkośćOdziału;
                wielkośćOdziału++;
            }
            if (globalnyCzas2 <= 0)
            {
                globalnyCzas2 = czas2;
                if (ileJeszczeWrogówWyprodukować > 0)
                {
                    ileJeszczeWrogówWyprodukować--;
                    k = losujCzyZLewej.Next(0, 2);
                    if (k == 0)
                    {
                        czyProdukowaćWrogówZLewej = false;
                    }
                    else
                    {
                        czyProdukowaćWrogówZLewej = true;
                    }
                    this.DodajPrzeciwnika(czyProdukowaćWrogówZLewej);
                }
            }
        }

        private void WykonajKrokGracza()
        {
            if (statekGracza.StanGracza == (int)StanyGracza.WLewo)
            {
                statekGracza.X -= graczDługośćKroku;
                if (statekGracza.X < 0.5 * graczHitboxX + graczDługośćKroku)
                {
                    statekGracza.StanGracza = (int)StanyGracza.Żaden;
                    statekGracza.X = 0.5 * graczHitboxX + graczDługośćKroku;
                }

            }
            if (statekGracza.StanGracza == (int)StanyGracza.WPrawo)
            {
                statekGracza.X += graczDługośćKroku;
                if (statekGracza.X > 1.0 - (0.5 * graczHitboxX + graczDługośćKroku))
                {
                    statekGracza.StanGracza = (int)StanyGracza.Żaden;
                    statekGracza.X = 1.0 - (0.5 * graczHitboxX + graczDługośćKroku);
                }
            }
        }

        private void WykonajKrokiPrzeciwników()
        {
            int k, k2;
            Random r = new Random();
            for (int i = 0; i < przeciwnicy.Length; i++)
            {
                if (przeciwnicy[i].CzyIstnieje)
                {
                    switch (przeciwnicy[i].StanPrzeciwnika)
                    {
                        case (int)StanyPrzeciwnika.ParabolaWLewo: // jeśli się nie kompiluje należy zamienić wartość na case 0:
                            przeciwnicy[i].X -= przeciwnikDługośćKroku * 1.3;
                            przeciwnicy[i].Y = Silnik.WartośćParabolaWLewo(przeciwnicy[i].X);
                            if (przeciwnicy[i].Y > (1.0 - (0.5 * przeciwnikHitboxY + 2 * przeciwnikDługośćKroku)))
                            {
                                przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.KontynuujPoziomoWPrawo;
                                przeciwnicy[i].Y = 1.0 - (0.5 * przeciwnikHitboxY);
                                // już to ma a dwie pozostałe wielkości bez zmian: przeciwnicy[i].IleJeszczeSchodzić = 0.0;
                            }
                            break;
                        case (int)StanyPrzeciwnika.ParabolaWPrawo: // jeśli się nie kompiluje należy zamienić wartość na case 1:
                            przeciwnicy[i].X += przeciwnikDługośćKroku * 1.3;
                            przeciwnicy[i].Y = Silnik.WartośćParabolaWPrawo(przeciwnicy[i].X);
                            if (przeciwnicy[i].Y > (1.0 - (0.5 * przeciwnikHitboxY + 2.0 * przeciwnikDługośćKroku)))
                            {
                                przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.KontynuujPoziomoWLewo;
                                przeciwnicy[i].Y = 1.0 - (0.5 * przeciwnikHitboxY);
                                // już to ma a dwie pozostałe wielkości bez zmian: przeciwnicy[i].IleJeszczeSchodzić = 0.0;
                            }
                            break;
                        case (int)StanyPrzeciwnika.KontynuujPoziomoWLewo: // jeśli się nie kompiluje należy zamienić wartość na case 2:
                            przeciwnicy[i].X -= przeciwnikDługośćKroku;
                            if (przeciwnicy[i].X < 0.5 * przeciwnikHitboxX + przeciwnikDługośćKroku)
                            {
                                przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.Schodzenie;
                                przeciwnicy[i].X = 0.5 * przeciwnikHitboxX;
                                przeciwnicy[i].IleJeszczeSchodzić = 0.15;
                            }
                            break;
                        case (int)StanyPrzeciwnika.KontynuujPoziomoWPrawo: // jeśli się nie kompiluje należy zamienić wartość na case 3:
                            przeciwnicy[i].X += przeciwnikDługośćKroku;
                            if (przeciwnicy[i].X > 1.0 - (0.5 * przeciwnikHitboxX + przeciwnikDługośćKroku))
                            {
                                przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.Schodzenie;
                                przeciwnicy[i].X = 1.0 - 0.5 * przeciwnikHitboxX;
                                przeciwnicy[i].IleJeszczeSchodzić = 0.15;
                            }
                            break;
                        case (int)StanyPrzeciwnika.Schodzenie: // jeśli się nie kompiluje należy zamienić wartość na case 4:
                            przeciwnicy[i].Y -= przeciwnikDługośćKroku;
                            przeciwnicy[i].IleJeszczeSchodzić -= przeciwnikDługośćKroku;
                            if (przeciwnicy[i].IleJeszczeSchodzić <= 0.0 || przeciwnicy[i].Y <= statekGracza.Y)
                            {
                                przeciwnicy[i].IleJeszczeSchodzić = 0.0;
                                if (przeciwnicy[i].Y <= statekGracza.Y)
                                {
                                    przeciwnicy[i].Y = statekGracza.Y;
                                }
                                if (Math.Abs(przeciwnicy[i].X) < Math.Abs(1.0 - przeciwnicy[i].X))
                                {
                                    przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.KontynuujPoziomoWPrawo;
                                }
                                else
                                {
                                    przeciwnicy[i].StanPrzeciwnika = (int)StanyPrzeciwnika.KontynuujPoziomoWLewo;
                                }
                            }
                            break;
                    }
                    k = Silnik.Losuj(0, rzadkośćStrzelania * 4); //fala globalna (strzelają wszyscy)
                    if (k == 0)
                    {
                        this.DodajPociskWroga(przeciwnicy[i].X, przeciwnicy[i].Y - 0.5 * przeciwnikHitboxY - 0.5 * pociskHitboxY);
                    }
                    //strzały niezależne
                    k2 = r.Next(0, rzadkośćStrzelania);
                    if (k2 == 0 && k != 0)
                    {
                        this.DodajPociskWroga(przeciwnicy[i].X, przeciwnicy[i].Y - 0.5 * przeciwnikHitboxY - 0.5 * pociskHitboxY);
                    }
                }
            }
        }

        private void WykonajKrokiPocisków()
        {
            for (int i = 0; i < pociskiGracza.Length; i++)
            {
                pociskiGracza[i].Y += pociskGraczaDługośćKroku;
                if (pociskiGracza[i].Y > 1.0 - (0.5 * pociskHitboxY + pociskGraczaDługośćKroku))
                {
                    pociskiGracza[i].CzyIstnieje = false;
                }
            }
            for (int i = 0; i < pociskiWroga.Length; i++)
            {
                pociskiWroga[i].Y -= pociskWrogaDługośćKroku;
                if (pociskiWroga[i].Y < 0.5 * pociskHitboxY + pociskGraczaDługośćKroku)
                {
                    pociskiWroga[i].CzyIstnieje = false;
                }
            }
        }

        private void WykryjKolizjeGracza()
        {
            bool p1, p2, p3, p4;

            // gracza ze statkiem wroga:
            for (int i = 0; i < przeciwnicy.Length; i++)
            {
                if (przeciwnicy[i].CzyIstnieje)
                {
                    if (przeciwnicy[i].Y < statekGracza.Y + 0.5 * graczHitboxY + 0.5 * przeciwnikHitboxY)
                    {
                        if (przeciwnicy[i].X > statekGracza.X - 0.5 * graczHitboxX - 0.5 * przeciwnikHitboxX && przeciwnicy[i].X < statekGracza.X + 0.5 * graczHitboxX + 0.5 * przeciwnikHitboxX)
                        {
                            liczbaŻyć--;
                            if (liczbaŻyć <= 0)
                            {
                                graSkończona = true;
                            }
                            przeciwnicy[i].CzyIstnieje = false;
                        }
                    }
                }
            }

            // gracza z pociskiem wroga:
            for (int i = 0; i < pociskiWroga.Length; i++)
            {
                if (pociskiWroga[i].CzyIstnieje)
                {
                    p1 = false;
                    p2 = false;
                    p3 = false;
                    p4 = false;

                    p1 = (pociskiWroga[i].Y <= statekGracza.Y + 0.5 * graczHitboxY + 0.5 * pociskHitboxY);
                    if (p1)
                    {
                        p2 = (pociskiWroga[i].Y >= statekGracza.Y - 0.5 * graczHitboxY - 0.5 * pociskHitboxY);
                        if (p2)
                        {
                            p3 = (pociskiWroga[i].X <= statekGracza.X + 0.5 * graczHitboxX + 0.5 * pociskHitboxX);
                            if (p3)
                            {
                                p4 = (pociskiWroga[i].X >= statekGracza.X - 1.0 * graczHitboxX - 0.5 * pociskHitboxX);
                            }
                        }
                    }

                    if (p1 && p2 && p3 && p4)
                    {
                        liczbaŻyć--;
                        if (liczbaŻyć <= 0)
                        {
                            graSkończona = true;
                        }
                        pociskiWroga[i].CzyIstnieje = false;
                    }
                }
            }
        }

        private void WykryjKolizjePocisków()
        {
            bool p1, p2, p3, p4;

            // pocisku ze statkiem wroga:
            for (int i = 0; i < pociskiGracza.Length; i++)
            {
                if (pociskiGracza[i].CzyIstnieje)
                {
                    for (int j = 0; j < przeciwnicy.Length; j++)
                    {
                        if (przeciwnicy[j].CzyIstnieje)
                        {
                            p1 = false;
                            p2 = false;
                            p3 = false;
                            p4 = false;

                            p1 = (pociskiGracza[i].Y <= przeciwnicy[j].Y + 0.5 * przeciwnikHitboxY + 0.5 * pociskHitboxY);
                            if (p1)
                            {
                                p2 = (pociskiGracza[i].Y >= przeciwnicy[j].Y - 0.5 * przeciwnikHitboxY - 0.5 * pociskHitboxY);
                                if (p2)
                                {
                                    p3 = (pociskiGracza[i].X <= przeciwnicy[j].X + 0.5 * przeciwnikHitboxX + 0.5 * pociskHitboxX);
                                    if (p3)
                                    {
                                        p4 = (pociskiGracza[i].X >= przeciwnicy[j].X - 1.0 * przeciwnikHitboxX - 0.5 * pociskHitboxX);
                                    }
                                }
                            }

                            if (p1 && p2 && p3 && p4)
                            {
                                liczbaPunktów += deltaPKT;
                                przeciwnicy[j].CzyIstnieje = false;
                                pociskiGracza[i].CzyIstnieje = false;
                            }
                        }
                    }
                }
            }
        }

        public int ZwróćXStatku()
        {
            return Convert.ToInt32(przestrzeńXpx * (statekGracza.X - 0.5 * graczHitboxX));
        }

        public int ZwróćYStatku()
        {
            return Convert.ToInt32(przestrzeńYpx * (1.0 - (statekGracza.Y + 0.5 * graczHitboxY)));
        }

        public int ZwróćXPrzeciwnika(int i)
        {
            if (i < 0 || przeciwnicy.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do przeciwnika. (i)");
            }
            return Convert.ToInt32(przestrzeńXpx * (przeciwnicy[i].X - 0.5 * przeciwnikHitboxX));
        }

        public int ZwróćYPrzeciwnika(int i)
        {
            if (i < 0 || przeciwnicy.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do przeciwnika. (i)");
            }
            return Convert.ToInt32(przestrzeńYpx * (1.0 - (przeciwnicy[i].Y + 0.5 * przeciwnikHitboxY)));
        }

        public int ZwróćXPociskuGracza(int i)
        {
            if (i < 0 || pociskiGracza.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return Convert.ToInt32(przestrzeńXpx * (pociskiGracza[i].X - 0.5 * pociskHitboxX));
        }

        public int ZwróćYPociskuGracza(int i)
        {
            if (i < 0 || pociskiGracza.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return Convert.ToInt32(przestrzeńYpx * (1.0 - (pociskiGracza[i].Y + 0.5 * pociskHitboxY)));
        }

        public int ZwróćXPociskuWroga(int i)
        {
            if (i < 0 || pociskiWroga.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return Convert.ToInt32(przestrzeńXpx * (pociskiWroga[i].X - 0.5 * pociskHitboxX));
        }

        public int ZwróćYPociskuWroga(int i)
        {
            if (i < 0 || pociskiWroga.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return Convert.ToInt32(przestrzeńYpx * (1.0 - (pociskiWroga[i].Y + 0.5 * pociskHitboxY)));
        }

        public bool CzyPrzeciwnikIstnieje(int i)
        {
            if (i < 0 || przeciwnicy.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do przeciwnika. (i)");
            }
            return przeciwnicy[i].CzyIstnieje;
        }

        public bool CzyPociskGraczaIstnieje(int i)
        {
            if (i < 0 || pociskiGracza.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return pociskiGracza[i].CzyIstnieje;
        }

        public bool CzyPociskWrogaIstnieje(int i)
        {
            if (i < 0 || pociskiWroga.Length <= i)
            {
                throw new ArgumentException("Nieprawidłowe odwołanie do pocisku. (i)");
            }
            return pociskiWroga[i].CzyIstnieje;
        }

        public void NaciśniętoKlawiszSpace()
        {
            if (pociskiGracza != null)
                this.DodajPociskGracza(statekGracza.X - 0.5 * graczHitboxX + 0.5 * pociskHitboxX, statekGracza.Y + 0.5 * graczHitboxY + 0.5 * pociskHitboxY);
        }

        public void UstawKlawiszStrzałkiWLewo()
        {
            if (statekGracza != null)
                statekGracza.StanGracza = (int)StanyGracza.WLewo;
        }

        public void UstawKlawiszStrzałkiWPrawo()
        {
            if (statekGracza != null)
                statekGracza.StanGracza = (int)StanyGracza.WPrawo;
        }

        public void UstawKlawiszStrzałkiŻaden()
        {
            if (statekGracza != null)
                statekGracza.StanGracza = (int)StanyGracza.Żaden;
        }
    }
}
