﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Loz;

namespace Galaga
{
    public partial class Game : Form
    {
        private Silnik silnik = new Silnik();
        private PictureBox[] przeciwnicy;
        private PictureBox[] pociskiGracza;
        private PictureBox[] pociskiWroga;
        private PictureBox gracz = new PictureBox();

        private double playerHitboxXf = 0.08;
        private double playerHitboxYf = 0.08;
        public Game()
        {
            InitializeComponent();
        }

        private Size newComponentSize(double wRatio, double hRatio)
        {
            return new Size(Convert.ToInt32((this.Size.Width - InfoPanel.Size.Width) * wRatio), Convert.ToInt32(this.Size.Height * hRatio));
        }
        private void RescaleGame(object sender, EventArgs e)
        {
            Control control = (Control)sender;
            silnik.PrzeskalujRozmiary(control.Size.Width - InfoPanel.Size.Width, control.Size.Height);
            if(silnik.LiczbaŻyć != 0)
            {
                gracz.Size = newComponentSize(playerHitboxXf, playerHitboxYf);
                if(silnik != null)
                {
                    for(int i = 0; i < silnik.MaxLiczbaPrzeciwników; i++)
                    {
                        przeciwnicy[i].Size = newComponentSize(playerHitboxXf, playerHitboxYf);
                    }
                    for(int i = 0; i < silnik.MaxLiczbaPociskówGracza; i++)
                    {
                        pociskiGracza[i].Size = newComponentSize(playerHitboxXf, playerHitboxYf);
                    }
                    for(int i = 0; i < silnik.MaxLiczbaPociskówWroga; i++)
                    {
                        pociskiWroga[i].Size = newComponentSize(playerHitboxXf, playerHitboxYf);
                    }
                }
            }
        }

        private void StartGame(object sender, EventArgs e)
        {
            silnik.Resetuj(Ż: 3, PHX: playerHitboxXf, PHY: playerHitboxYf);
            silnik.WykonajKrok();
            int maxLiczbaPrzeciwnikow = silnik.MaxLiczbaPrzeciwników;
            int maxLiczbaPociskowGracza = silnik.MaxLiczbaPociskówGracza;
            int maxLiczbaPociskowWroga = silnik.MaxLiczbaPociskówWroga;
            przeciwnicy = new PictureBox[silnik.MaxLiczbaPrzeciwników];
            pociskiGracza = new PictureBox[silnik.MaxLiczbaPociskówGracza];
            pociskiWroga = new PictureBox[silnik.MaxLiczbaPociskówWroga];
            gracz.Image = Galaga.Properties.Resources.gracz2;
            gracz.SizeMode = PictureBoxSizeMode.StretchImage;
            this.Controls.Add(gracz);
            for(int i = 0; i < maxLiczbaPrzeciwnikow; i++)
            {
                przeciwnicy[i] = new PictureBox();
                przeciwnicy[i].Image = Galaga.Properties.Resources.wrog1;
                przeciwnicy[i].Image.RotateFlip(RotateFlipType.RotateNoneFlipY);
                przeciwnicy[i].SizeMode = PictureBoxSizeMode.StretchImage;
                przeciwnicy[i].Hide();
                this.Controls.Add(przeciwnicy[i]);
            }
            for(int i = 0; i < maxLiczbaPociskowGracza; i++)
            {
                pociskiGracza[i] = new PictureBox();
                pociskiGracza[i].Image = Galaga.Properties.Resources.StrzalGracza1;
                pociskiGracza[i].SizeMode = PictureBoxSizeMode.StretchImage;
                pociskiGracza[i].Hide();
                this.Controls.Add(pociskiGracza[i]);
            }
            for(int i = 0; i < maxLiczbaPociskowWroga; i++)
            {
                pociskiWroga[i] = new PictureBox();
                pociskiWroga[i].Image = Galaga.Properties.Resources.StrzalWroga1;
                pociskiWroga[i].SizeMode = PictureBoxSizeMode.StretchImage;
                pociskiWroga[i].Hide();
                this.Controls.Add(pociskiWroga[i]);

            }
            RescaleGame(this, null);
            mainTimer.Start();
        }


        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if(e.KeyCode == Keys.Left)
                silnik.UstawKlawiszStrzałkiWLewo();
            else if(e.KeyCode == Keys.Right)
                silnik.UstawKlawiszStrzałkiWPrawo();
            if(e.KeyCode == Keys.Space)
            {
                silnik.NaciśniętoKlawiszSpace();
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            if(e.KeyCode == Keys.Left || e.KeyCode == Keys.Right)
                silnik.UstawKlawiszStrzałkiŻaden();
        }
        private void DrawEnemies()
        {
            for(int i = 0; i < silnik.MaxLiczbaPrzeciwników; i++)
            {
                PictureBox przeciwnik = przeciwnicy[i];
                if(silnik.CzyPrzeciwnikIstnieje(i))
                {
                    przeciwnik.Location = new Point(silnik.ZwróćXPrzeciwnika(i), silnik.ZwróćYPrzeciwnika(i));
                    if(!przeciwnik.Visible)
                    {
                        przeciwnik.Show();
                    }
                }
                else
                {
                    if(przeciwnik.Visible)
                    {
                        przeciwnik.Hide();
                    }
                }
            }
        }
        private void DrawPlayerProjectiles()
        {
            for(int i = 0; i < silnik.MaxLiczbaPociskówGracza; i++)
            {
                PictureBox pociskGracza = pociskiGracza[i];
                if(silnik.CzyPociskGraczaIstnieje(i))
                {
                    pociskGracza.Location = new Point(silnik.ZwróćXPociskuGracza(i), silnik.ZwróćYPociskuGracza(i));
                    if(!pociskGracza.Visible)
                    {
                        pociskGracza.Show();
                    }
                }
                else
                {
                    if(pociskGracza.Visible)
                    {
                        pociskGracza.Hide();
                    }
                }
            }
        }
        private void DrawEnemyProjectiles()
        {
            for(int i = 0; i < silnik.MaxLiczbaPociskówWroga; i++)
            {
                PictureBox pociskWroga = pociskiWroga[i];
                if(silnik.CzyPociskWrogaIstnieje(i))
                {
                    pociskWroga.Location = new Point(silnik.ZwróćXPociskuWroga(i), silnik.ZwróćYPociskuWroga(i));
                    if(!pociskWroga.Visible)
                    {
                        pociskWroga.Show();
                    }
                }
                else
                {
                    if(pociskWroga.Visible)
                    {
                        pociskWroga.Hide();
                    }
                }
            }
        }
        private void Klatka(object sender, EventArgs e)
        {
            if(!silnik.GraSkończona)
            {
                silnik.WykonajKrok();
                gracz.Location = new Point(silnik.ZwróćXStatku(), silnik.ZwróćYStatku());
                DrawEnemies();
                DrawPlayerProjectiles();
                DrawEnemyProjectiles();
                DisplayHealth();
            }
            else
            {
                mainTimer.Stop();
                MessageBox.Show($"Gratulacje, zdobyłeś {silnik.LiczbaPunktów} punktów!.");
                Imie imie = new Imie(silnik.LiczbaPunktów);
                imie.ShowDialog();
                this.Close();
            }
            Score.Text = silnik.LiczbaPunktów.ToString();
            //printDebugInfo();
        }
        private void DisplayHealth()
        {
            int lifes = silnik.LiczbaŻyć;
            HealthBox1.Show();
            HealthBox2.Show();
            HealthBox3.Show();

            if(lifes > 3)
                HealthText.Text = $"{lifes - 3}+";
            else
                HealthText.Text = "";
            if(lifes <= 2)
            {
                HealthBox3.Hide();
                if(lifes <= 1)
                {
                    HealthBox2.Hide();
                    if(lifes <= 0)
                    {
                        HealthBox1.Hide();
                    }
                }
            }

        }

        private void PrintDebugInfo()
        {
            playerPos.Text = $"playerPos: ({gracz.Location.X},{gracz.Location.Y})";
            enginePlayerPos.Text = $"enginePlayerPos: ({silnik.ZwróćXStatku()},{silnik.ZwróćYStatku()})";
            mousePos.Text = $"mousePos: ({Cursor.Position.X - this.Left}, {Cursor.Position.Y - this.Top})";
            playerSize.Text = $"playerSize: ({gracz.Size.Width},{gracz.Size.Height})";
            firstShotPos.Text = $"firstShotPos: ({pociskiGracza[0].Location.X},{pociskiGracza[0].Location.Y})";
            playerLifes.Text = $"lifes: {silnik.LiczbaŻyć}";
            //score.Text = $"score: {silnik.LiczbaPunktów}";
        }

        private void Game_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.OpenForms[0].Show();
        }
    }
}
